#!/usr/bin/env python
#-*- coding:utf-8 -*-

import os, sys
import traceback

import rfid

MAGIC = "\xde\xad\xfa\xce" + "\xa9" * 8 + "\xf1\xf2\xf3\xf4"

N = 308437044275067938131653453561001047357000826062737759785845990336
C = 111111111111111111111111111111111111111111111111111111111111112000
E = 31337

def main():
    rfid.server(process_card)

def state(s):
    print "mutex IN"
    while len(os.listdir("../status/")): pass
    print "mutex OUT"
    open("../status/%d" % int(s), "wb").close()

def grant(card):
    flag = open("c:\\flag.txt").read()
    card.write(1, 2, flag[:16])
    state(4)
    print "Saved flag!"
    return

def deny(s):
    state(0)
    print s

def process_card(card):
    state(1)
    if card['type'] != "Mifare 4K":
        return deny("Bad card type")

    state(2)
    try:
        serial = s2n(card.read(0, 0))
        print hex(serial)

        magic = card.read(0, 1)
        if magic != MAGIC:
            return deny("Bad magic")

        state(3)

        key = (s2n(card.read(1, 0)) << 128) | s2n(card.read(1, 1))

        if pow(key + pow(serial, E, N), 2, N) == C:
            return grant(card)
        else:
            return deny("Bad key")
    except:
        print "Error"
        traceback.print_exc(file=sys.stdout)
        state(0);
    return

def s2n(s):
    if not len(s):
        return 0
    return int(s.encode("hex"), 16)

def n2s(n):
    s = hex(n)[2:].rstrip("L")
    if len(s) % 2 != 0:
        s = "0" + s
    return s.decode("hex")


if __name__ == "__main__":
    main()
